/**
 * Blink
 * Activa el led durante 500ms y lo desactiva otros 500ms
 * 
 * Se añaden constantes para mejorar la legibilidad
 */
const int led = 13;
const unsigned long retardo = 500;
const bool EN = HIGH;
const bool AP = LOW;

/**
 * setup
 * 
 * inicialización del sistema
 */
void setup() {
  // inicializa el led como salida
  pinMode(led, OUTPUT);

  // ponemos el led en un estado conocido
  digitalWrite(led, AP);    // apaga el led
}

/**
 * loop
 * 
 * Se invoca repetitivamente hasta desconectar la alimentación
 */
void loop() {
  digitalWrite(led, EN);    // enciende el led
  delay(retardo);           // espera medio segundo
  digitalWrite(led, AP);    // apaga el led
  delay(retardo);           // espera medio segundo
}
