/**
 * Blink
 * Activa el led durante 500ms y lo desactiva otros 500ms
 */
const int led = 13;
const unsigned long retardo = 500;
const bool EN = HIGH;
const bool AP = LOW;

/**
 * setup
 * 
 * inicialización del sistema
 */
void setup() {
  // inicializa el led como salida
  pinMode(led, OUTPUT);

  // ponemos el led en un estado conocido
  digitalWrite(led, AP);   // led apagado  
}

/**
 * loop
 * 
 * Se invoca repetitivamente hasta desconectar la alimentación
 */
void loop() {
  blink();
}


/**
 * blink
 * 
 * Hace parpadear el led a intervalos regulares
 */
void blink() {
  static bool encendido = false;
  static unsigned long tiempo = millis();
  
  if (millis() - tiempo >= retardo) {
    
    tiempo = millis();
    
    if (encendido) {
      encendido = false;
      digitalWrite(led, AP);    // apaga el led
    }
    else {
      encendido = true;
      digitalWrite(led, EN);    // apaga el led
    }    
  }
}
