#include "Semaforo.h"

Semaforo::Semaforo() {
  _rojo = 2;
  _ambar = 13;
  _verde = 4;

  _S = S_PRECAUCION_EN;

  pinMode(_rojo, OUTPUT);
  pinMode(_ambar, OUTPUT);
  pinMode(_verde, OUTPUT);

  digitalWrite(_rojo, LOW);
  digitalWrite(_ambar, HIGH);
  digitalWrite(_verde, LOW);
  
  _retardo_precaucion = 500;
  
  _retardo_rojo = 10000;
  _retardo_ambar = 3000;
  _retardo_verde = 6000;
  
  tiempo = millis();
}


void Semaforo::proceso() {
//  #ifdef DEBUG
//    Serial.print(F("Entro en proceso _S = "));
//    Serial.print(_S);
//  #endif
  
  switch(_S) {
//    caso 0:
//      break;
      
    case S_APAGADO:
      digitalWrite(_rojo, LOW);
      digitalWrite(_ambar, LOW);
      digitalWrite(_verde, LOW);
      break;
      
    case S_NORMAL_ROJO:
      digitalWrite(_rojo, HIGH);
      digitalWrite(_ambar, LOW);
      digitalWrite(_verde, LOW);

      if (millis() - tiempo >= _retardo_rojo) {
        // Apagar ambar y pasar a S_PRECAUCION_AP
        tiempo = millis();

        _S = S_NORMAL_VERDE;
        digitalWrite(_rojo, LOW);
        digitalWrite(_ambar, LOW);
        digitalWrite(_verde, HIGH);

        #ifdef DEBUG
          Serial.println(F("Semaforo: __V"));
        #endif
      }
      break;
      
    case S_NORMAL_AMBAR:
      digitalWrite(_rojo, LOW);
      digitalWrite(_ambar, HIGH);
      digitalWrite(_verde, LOW);

      if (millis() - tiempo >= _retardo_ambar) {
        // Apagar ambar y pasar a S_PRECAUCION_AP
        tiempo = millis();

        _S = S_NORMAL_ROJO;
        digitalWrite(_rojo, HIGH);
        digitalWrite(_ambar, LOW);
        digitalWrite(_verde, LOW);

        #ifdef DEBUG
          Serial.println(F("Semaforo: R__"));
        #endif
      }
      break;
      
    case S_NORMAL_VERDE:
      digitalWrite(_rojo, LOW);
      digitalWrite(_ambar, LOW);
      digitalWrite(_verde, HIGH);

      if (millis() - tiempo >= _retardo_verde) {
        // Apagar ambar y pasar a S_PRECAUCION_AP
        tiempo = millis();

        _S = S_NORMAL_AMBAR;
        digitalWrite(_rojo, LOW);
        digitalWrite(_ambar, HIGH);
        digitalWrite(_verde, LOW);

        #ifdef DEBUG
          Serial.println(F("Semaforo: _A_"));
        #endif
      }
      break;
      
    case S_PRECAUCION_AP:
      if (millis() - tiempo >= _retardo_precaucion) {
        // Apagar ambar y pasar a S_PRECAUCION_AP
        tiempo = millis();

        _S = S_PRECAUCION_EN;
        digitalWrite(_rojo, LOW);
        digitalWrite(_ambar, HIGH);
        digitalWrite(_verde, LOW);

        #ifdef DEBUG
          Serial.println(F("Semaforo: _A_"));
        #endif
      }
      break;
      
    case S_PRECAUCION_EN:
      if (millis() - tiempo >= _retardo_precaucion) {
        // Apagar ambar y pasar a S_PRECAUCION_AP
        tiempo = millis();

        _S = S_PRECAUCION_AP;
        digitalWrite(_rojo, LOW);
        digitalWrite(_ambar, LOW);
        digitalWrite(_verde, LOW);

        #ifdef DEBUG
          Serial.println(F("Semaforo: ___"));
        #endif
      }
      break;

    default:
      Semaforo();
  }
  
//  #ifdef DEBUG
//    Serial.print(F(" --> Saliendo de proceso _S = "));
//    Serial.println(_S);
//  #endif  
}


void Semaforo::setModo(int modo) {
  if (modo > 0 && modo < 4) {
    _S = modo;
    tiempo = millis();
  }
}

